package net.zzforrest.ld29;

import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;

public class Art
{
	static boolean muted = false;
	
	public static BufferedImage player = loadImage("player.png");
	public static BufferedImage paper = loadImage("paper.png");
	public static BufferedImage paper1 = loadImage("paper1.png");
	public static BufferedImage paper2 = loadImage("paper2.png");
	public static BufferedImage pin = loadImage("pin.png");
	public static BufferedImage blocks = loadImage("blocks.png");
	public static BufferedImage heart = loadImage("heart.png");
	public static BufferedImage enemy = loadImage("enemy.png");
	public static BufferedImage background = loadImage("background.png");
	
	public static Clip coin = loadClip("coin.wav");
	public static Clip powerup = loadClip("heart.wav");
	public static Clip pindrop = loadClip("pindrop.wav");
	public static Clip hurt = loadClip("hurt.wav");
	public static Clip die = loadClip("die.wav");
	public static Clip slide = loadClip("slide.wav");
	
	public static BufferedImage loadImage(String filename)
	{
		BufferedImage res = null;
		
		try
		{
			BufferedImage org = ImageIO.read(Art.class.getClass().getResource("/images/" + filename));
			res = new BufferedImage(org.getWidth(), org.getHeight(), BufferedImage.TYPE_INT_ARGB);
			Graphics g = res.getGraphics();
			g.drawImage(org, 0, 0, null);
			g.dispose();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
		
		return res;
	}
	
	public static Clip loadClip(String filename)
	{
		Clip res = null;
		
		try
		{
			AudioInputStream audioIn = AudioSystem.getAudioInputStream(Art.class.getClass().getResource("/sounds/" + filename));
			res = AudioSystem.getClip();
			res.open(audioIn);
		} catch (UnsupportedAudioFileException e)
		{
			e.printStackTrace();
		} catch (IOException e)
		{
			e.printStackTrace();
		} catch (LineUnavailableException e)
		{
			e.printStackTrace();
		}
		
		return res;
	}
	
	public static void playClip(Clip clip)
	{
		if(muted)
			return;
		clip.stop();
		clip.setFramePosition(0);
		clip.start();
	}
	
	public static void mute()
	{
		muted = !muted;
	}
}