package net.zzforrest.ld29;

import java.awt.image.BufferedImage;
import java.io.IOException;

import javax.imageio.ImageIO;

public class Bitmap
{
	int width;
	int height;
	
	int[] pixels;
	
	public Bitmap(String filename)
	{
		try
		{
			BufferedImage res = ImageIO.read(this.getClass().getResource("/images/" + filename));
			
			width = res.getWidth();
			height = res.getHeight();
			
			pixels = new int[width * height];
			res.getRGB(0, 0, width, height, pixels, 0, width);
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}
	
	public int getWidth()
	{
		return width;
	}
	
	public int getHeight()
	{
		return height;
	}
	
	public int[] getPixels()
	{
		return pixels;
	}
	
	public int getPixel(int x, int y)
	{
		if(x < 0 || y < 0 || x >= width || y >= height)
		{
			return 0;
		}
		
		return pixels[x + y * width];
	}
}