package net.zzforrest.ld29;

import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

public class Input implements KeyListener, MouseListener, MouseMotionListener, FocusListener
{
	public static final int keycodes = 255;
	
	boolean[] keys = new boolean[keycodes];
	boolean[] pressedkeys = new boolean[keycodes];
	boolean mousedown;
	int mx;
	int my;
	boolean focused;
	
	public void update()
	{
		pressedkeys = new boolean[keycodes];
	}
	
	public boolean getKey(int key)
	{
		if(key < keycodes)
			if(keys[key])
				return true;
		
		return false;
	}
	
	public boolean getKeyPressed(int key)
	{
		if(key < keycodes)
			if(pressedkeys[key])
				return true;
		
		return false;
	}
	
	public boolean getMouseDown()
	{
		return mousedown;
	}
	
	public boolean getFocused()
	{
		return focused;
	}
	
	public int getMouseX()
	{
		return mx;
	}
	
	public int getMouseY()
	{
		return my;
	}
	
	public void focusGained(FocusEvent e)
	{
		focused = true;
	}
	
	public void focusLost(FocusEvent e)
	{
		focused = false;
	}
	
	public void mouseDragged(MouseEvent e)
	{
		mx = e.getX();
		my = e.getY();
	}
	
	public void mouseMoved(MouseEvent e)
	{
		mx = e.getX();
		my = e.getY();
	}
	
	public void mouseClicked(MouseEvent e)
	{
		
	}
	
	public void mouseEntered(MouseEvent e)
	{
		
	}
	
	public void mouseExited(MouseEvent e)
	{
		
	}
	
	public void mousePressed(MouseEvent e)
	{
		mousedown = true;
	}
	
	public void mouseReleased(MouseEvent e)
	{
		mousedown = false;
	}
	
	public void keyPressed(KeyEvent e)
	{
		if(e.getKeyCode() < keycodes)
		{
			keys[e.getKeyCode()] = true;
			pressedkeys[e.getKeyCode()] = true;
		}
	}
	
	public void keyReleased(KeyEvent e)
	{
		if(e.getKeyCode() < keycodes)
			keys[e.getKeyCode()] = false;
	}
	
	public void keyTyped(KeyEvent e)
	{
		
	}
}