package net.zzforrest.ld29;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.util.Random;

import net.zzforrest.ld29.animation.Animation;
import net.zzforrest.ld29.entity.Entity;

public class Util
{
	public static final Random random = new Random();
	
	public static boolean isColliding(Entity e1, Entity e2)
	{
		if(e1.getX() + e1.getW() < e2.getX())
			return false;
		if(e2.getX() + e2.getW() < e1.getX())
			return false;
		if(e1.getY() + e1.getH() < e2.getY())
			return false;
		if(e2.getY() + e2.getH() < e1.getY())
			return false;
		
		return true;
	}
	
	public static boolean isColliding(Entity e1, int x, int y, int w, int h)
	{
		if(e1.getX() + e1.getW() < x)
			return false;
		if(x + w < e1.getX())
			return false;
		if(e1.getY() + e1.getH() < y)
			return false;
		if(y + h < e1.getY())
			return false;
		
		return true;
	}
	
	public static void renderRotatedAnimation(Animation animation, int x, int y, int cx, int cy, double angle, Graphics g)
	{
		Graphics2D g2 = (Graphics2D)g;
		AffineTransform transform = g2.getTransform();
		g2.rotate(angle, cx, cy);
		animation.render(g2, (int)x, (int)y);
		g2.setTransform(transform);
	}
}