package net.zzforrest.ld29.entity;

import java.awt.Graphics;

import net.zzforrest.ld29.Art;
import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.Util;
import net.zzforrest.ld29.animation.Animation;

public class Bullet extends Enemy
{
	float pxvel, pyvel;
	
	public Bullet(Game game, float x, float y, float xvel, float yvel)
	{
		super(game, x, y);
		
		w = 6;
		h = 6;
		
		this.xvel = xvel;
		pxvel = xvel;
		this.yvel = yvel;
		pyvel = yvel;
		
		friction = 1;
		
		animation = new Animation(Art.enemy, 0, 85, 6, 6, 1, 1);
	}
	
	public void update()
	{
		super.update();
		
		if(xvel != pxvel || yvel != pyvel)
			die();
	}
	
	public void checkPlayer()
	{
		if (Util.isColliding(this, game.getPlayer()))
		{
			game.getPlayer().hurt();
			die();
		}
	}

	@Override
	public void render(Graphics g)
	{
		animation.render(g, (int)x, (int)y);
	}
}