package net.zzforrest.ld29.entity;

import java.awt.Graphics;

import net.zzforrest.ld29.Art;
import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.Util;
import net.zzforrest.ld29.animation.Animation;

public class Coin extends Entity
{
	Animation animation;

	public Coin(Game game, float x, float y)
	{
		super(game);

		this.x = x + 5;
		this.y = y + 5;

		w = 10;
		h = 10;

		animation = new Animation(Art.enemy, 200, 0, 60, 10, 6, 1).setDelay(5).loop(-1);
	}

	@Override
	public void update()
	{
		if(Util.isColliding(this, game.getPlayer()))
		{
			game.score(10);
			Art.playClip(Art.coin);
			die();
		}
		
		animation.update();
	}

	@Override
	public void render(Graphics g)
	{
		animation.render(g, (int)x, (int)y);
	}
}