package net.zzforrest.ld29.entity;

import net.zzforrest.ld29.Block;
import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.Util;
import net.zzforrest.ld29.animation.Animation;

public abstract class Enemy extends Entity
{
	protected Animation animation;

	protected float xvel;
	protected float yvel;

	protected float acceleration;
	protected float friction;

	public Enemy(Game game, float x, float y)
	{
		super(game);
		this.x = x;
		this.y = y;
	}

	@Override
	public void update()
	{
		Block[][] blocks = game.getBlocks();

		for (int i = (int) Math.floor(x + xvel) / 20; i < Math.floor(x + w
				+ xvel) / 20; i++)
		{
			if (i < 0 || i >= 32)
				break;
			for (int j = (int) Math.floor(y) / 20; j < Math.floor(y + h) / 20; j++)
			{
				if (j < 0 || j >= 24)
					break;

				if (blocks[i][j].isSolid())
				{
					xvel = 0; // if it's in range, it is impossible for it not
								// to collide. yay technicalities
				}
			}
		}

		x += xvel;

		for (int i = (int) Math.floor(x) / 20; i < Math.floor(x + w) / 20; i++)
		{
			if (i < 0 || i >= 32)
				break;
			for (int j = (int) Math.floor(y + yvel) / 20; j < Math.floor(y + h
					+ yvel) / 20; j++)
			{
				if (j < 0 || j >= 24)
					break;

				if (blocks[i][j].isSolid())
				{
					yvel = 0;
				}
			}
		}

		y += yvel;

		xvel *= friction;
		yvel *= friction;

		if (x < 0)
		{
			x = 0;
			xvel = 0;
		}
		if (x + w > 640)
		{
			x = 640 - w;
			xvel = 0;
		}
		if (y < 0)
		{
			y = 0;
			yvel = 0;
		}
		if (y + h > 480)
		{
			y = 480 - h;
			yvel = 0;
		}
		
		checkPlayer();
		
		animation.update();
	}
	
	public void checkPlayer()
	{
		if (Util.isColliding(this, game.getPlayer()))
			game.getPlayer().hurt();
	}
}