package net.zzforrest.ld29.entity;

import java.awt.Graphics;

import net.zzforrest.ld29.Art;
import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.Util;
import net.zzforrest.ld29.animation.Animation;

public class Heart extends Entity
{
	Animation animation;
	
	public Heart(Game game, float x, float y)
	{
		super(game);

		this.x = x + 5;
		this.y = y + 5;

		w = 20;
		h = 20;

		animation = new Animation(Art.heart, 0, 40, 80, 20, 4, 1).setDelay(5).loop(-1);
	}

	@Override
	public void update()
	{
		if(Util.isColliding(this, game.getPlayer()))
		{
			game.score(15);
			game.getPlayer().heal(1);
			Art.playClip(Art.powerup);
			die();
		}
		
		animation.update();
	}

	@Override
	public void render(Graphics g)
	{
		animation.render(g, (int)x, (int)y);
	}
}