package net.zzforrest.ld29.entity;

import java.awt.Graphics;

import net.zzforrest.ld29.Art;
import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.animation.Animation;

public class MovingSpike extends Enemy
{
	public MovingSpike(Game game, float x, float y)
	{
		super(game, x, y);
		acceleration = .05f;
		friction = .98f;
		w = 30;
		h = 20;
		animation = new Animation(Art.enemy, 0, 0, 120, 20, 4, 1).setDelay(7);
		animation.loop(-1);
	}

	public void update()
	{
		super.update();

		xvel += Math.signum(game.getPlayer().getX() - x) * acceleration;
		yvel += Math.signum(game.getPlayer().getY() - y) * acceleration;
	}

	@Override
	public void render(Graphics g)
	{
		animation.render(g, (int) x, (int) y);
	}
}