package net.zzforrest.ld29.entity;

import java.awt.Graphics;

import net.zzforrest.ld29.Art;
import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.Util;
import net.zzforrest.ld29.animation.Animation;

public class Roamer extends Enemy
{
	int dir;
	int tick;
	int lastdir;

	public Roamer(Game game, float x, float y)
	{
		super(game, x, y);
		animation = new Animation(Art.enemy, 0, 20, 23, 23, 1, 1);
		w = 23;
		h = 23;
		
		acceleration = 0.1f;
		friction = .96f;
		
		dir = Util.random.nextInt(4);
	}
	
	public void update()
	{
		super.update();
		
		if(xvel == 0 && yvel == 0)
			lastdir = tick - 61;
		
		if(tick - lastdir > 60)
		{
			dir = (dir + Util.random.nextInt(3) - 1) % 4;
			if(dir < 0)
				dir = 3;
			
			lastdir = tick;
		}
		
		switch (dir)
		{
		case 0:
			xvel += acceleration;
			break;
		case 1:
			yvel -= acceleration;
			break;
		case 2:
			xvel -= acceleration;
			break;
		case 3:
			yvel += acceleration;
			break;
		default:
			break;
		}
		
		tick ++;
	}
	
	@Override
	public void render(Graphics g)
	{
		animation.render(g, (int) x, (int) y);
	}
}