package net.zzforrest.ld29.entity;

import java.awt.Graphics;

import net.zzforrest.ld29.Art;
import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.Util;
import net.zzforrest.ld29.animation.Animation;

public class Shooter extends Enemy
{
	double dir;
	boolean shoot;
	
	public Shooter(Game game, float x, float y)
	{
		super(game, x + 4, y + 2);
		w = 12;
		h = 12;

		animation = new Animation(Art.enemy, 0, 70, 120, 15, 10, 1).setDelay(8)
				.loop(-1);
	}

	public void update()
	{
		super.update();
		
		float xd = game.getPlayer().getX() - x;
		float yd = game.getPlayer().getY() - y;
		
		dir = Math.atan2(yd, xd);
		
		if (animation.getFrame() == 4)
		{
			if(shoot)
			{
				float xv, yv;
			
				float dist = (float) Math.sqrt(xd * xd + yd * yd);
				
				float rat = 2f / dist;
				
				xv = xd * rat;
				yv = yd * rat;
				
				game.spawnEntity(new Bullet(game, x + 3, y + 3, xv, yv));
				
				shoot = false;
			}
		}
		else
			shoot = true;
	}

	@Override
	public void render(Graphics g)
	{
		Util.renderRotatedAnimation(animation, (int)x, (int)y, (int)x + w / 2, (int)y + h / 2, dir - Math.PI / 2, g);
	}
}