package net.zzforrest.ld29.menu;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.KeyEvent;

import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.Input;

public class MainMenu extends Menu
{
	private enum Screen
	{
		MAIN (new String[]{"Under the Paper","by zzforrest","","Play","About","Credits","Controls"}, 3, 6),
		ABOUT (new String[]{"Game made in 48 hours for the Ludum Dare competition","ludumdare.com","","Contact me about any issues / bugs at","http://zzforrest.weebly.com/contact-me.html"}),
		CREDITS (new String[]{"Programming - Blake Doeren","'A Day in September' font - @MARSNEV"}),
		CONTROLS (new String[]{"Arrow Keys - move","Space / X - pull pin","P - pause","M - mute"});
		
		private String[] text;
		private int optionstart;
		private int optionend;
		private boolean options;

		Screen(String[] text)
		{
			this.text = text;
			options = false;
		}

		Screen(String[] text, int optionstart, int optionend)
		{
			this.text = text;
			this.optionstart = optionstart;
			this.optionend = optionend;
			options = true;
		}

		public String[] text()
		{
			return text;
		}

		public int optionstart()
		{
			return optionstart;
		}
		
		public int optionend()
		{
			return optionend;
		}
		
		public boolean options()
		{
			return options;
		}
	};
	
	private Screen screen;
	int choice;
	
	public MainMenu(Game game)
	{
		super(game);
		screen = Screen.MAIN;
		choice = 3;
	}

	@Override
	public void input(Input input)
	{
		if(screen.options())
		{
			if(input.getKeyPressed(KeyEvent.VK_DOWN))
				choice ++;
			if(input.getKeyPressed(KeyEvent.VK_UP))
				choice --;
			if(choice < screen.optionstart())
				choice = screen.optionend();
			if(choice > screen.optionend())
				choice = screen.optionstart();
			
			if(input.getKeyPressed(KeyEvent.VK_SPACE) || input.getKeyPressed(KeyEvent.VK_X))
			{
				if(screen == Screen.MAIN)
				{
					switch(choice)
					{
					case 3:
						game.setMenu(new Transition(game, this, new Blank(game, false)));
						break;
					case 4:
						screen = Screen.ABOUT;
						break;
					case 5:
						screen = Screen.CREDITS;
						break;
					case 6:
						screen = Screen.CONTROLS;
						break;
					default:
						break;
					}
				}
			}
		}
		
		else if(input.getKeyPressed(KeyEvent.VK_SPACE) || input.getKeyPressed(KeyEvent.VK_X))
			screen = Screen.MAIN;
	}

	@Override
	public void update()
	{

	}
	
	public void render(Graphics g)
	{
		super.render(g);

		for(int i = 0; i < screen.text().length; i ++)
		{
			g.setColor(Color.black);
			if(screen.options)
				if(i >= screen.optionstart() && i <= screen.optionend && choice != i)
					g.setColor(Color.gray);
			
			g.drawString(screen.text()[i], 10, 50 + 50 * i);
		}
	}
}