package net.zzforrest.ld29.menu;

import java.awt.Graphics;
import java.awt.image.BufferedImage;

import net.zzforrest.ld29.Art;
import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.Input;
import net.zzforrest.ld29.Util;

public abstract class Menu
{
	BufferedImage paper;

	protected Game game;

	public Menu(Game game)
	{
		this.game = game;
		int n = Util.random.nextInt(2);
		switch (n)
		{
		case 0:
			paper = Art.paper1;
			break;
		case 1:
			paper = Art.paper2;
			break;
		default:
			paper = Art.paper;
			break;
		}
	}

	public abstract void input(Input input);

	public abstract void update();

	public void render(Graphics g)
	{
		g.drawImage(paper, 0, 0, null);
	}
	
	public void render(Graphics g, int x, int y)
	{
		g.translate(x, y);
		render(g);
		g.translate(-x, -y);
	}
}