package net.zzforrest.ld29.menu;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.KeyEvent;

import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.Input;

public class Pause extends Menu
{
	String[] options;
	int choice;

	public Pause(Game game)
	{
		super(game);
		options = new String[] { "Resume Game", "Main Menu" };
		choice = 0;
	}

	@Override
	public void input(Input input)
	{
		if (input.getKeyPressed(KeyEvent.VK_DOWN))
			choice++;
		if (input.getKeyPressed(KeyEvent.VK_UP))
			choice--;
		if (choice < 0)
			choice = options.length - 1;
		if (choice == options.length)
			choice = 0;

		if (input.getKeyPressed(KeyEvent.VK_SPACE)
				|| input.getKeyPressed(KeyEvent.VK_X))
		{
			switch (choice)
			{
			case 0:
				game.setMenu(null);
				break;
			case 1:
				game.setMenu(new Transition(game, this, new MainMenu(game)));
				break;
			default:
				break;
			}
		}
	}

	@Override
	public void update()
	{

	}

	public void render(Graphics g)
	{
		super.render(g);

		g.drawString("PAUSED", 250, 100);

		for (int i = 0; i < options.length; i++)
		{
			g.setColor(Color.gray);

			if (i == choice)
				g.setColor(Color.black);

			g.drawString(options[i], 250, 150 + 50 * i);
		}
	}
}