package net.zzforrest.ld29.menu;

import java.awt.Graphics;
import java.awt.Graphics2D;

import net.zzforrest.ld29.Art;
import net.zzforrest.ld29.Game;
import net.zzforrest.ld29.Input;

public class Transition extends Menu
{
	public static final int LENGTH = 60;
	
	Menu menu1;
	Menu menu2;
	
	int tick;
	
	public Transition(Game game, Menu menu1, Menu menu2)
	{
		super(game);
		this.menu1 = menu1;
		this.menu2 = menu2;
		Art.playClip(Art.slide);
	}
	
	@Override
	public void input(Input input)
	{
		
	}
	
	@Override
	public void update()
	{
		tick ++;
		if(tick == LENGTH)
			game.setMenu(menu2);
	}
	
	public void render(Graphics g)
	{
		menu2.render(g);
		Graphics2D g2 = (Graphics2D) g;
		g2.translate(0, tick * 800 / LENGTH);
		g2.rotate(tick / Math.PI / 20.0);
		menu1.render(g2);
		g2.dispose();
	}
}